Index: uspace/srv/hid/display/window.h
===================================================================
--- uspace/srv/hid/display/window.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/window.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,4 +41,5 @@
 #include <errno.h>
 #include <io/pos_event.h>
+#include <stdbool.h>
 #include <types/gfx/context.h>
 #include <types/gfx/coord.h>
@@ -55,4 +56,5 @@
 extern void ds_window_bring_to_top(ds_window_t *);
 extern gfx_context_t *ds_window_get_ctx(ds_window_t *);
+extern bool ds_window_is_visible(ds_window_t *);
 extern errno_t ds_window_paint(ds_window_t *, gfx_rect_t *);
 errno_t ds_window_paint_preview(ds_window_t *, gfx_rect_t *);
@@ -61,13 +63,23 @@
 extern errno_t ds_window_post_focus_event(ds_window_t *);
 extern errno_t ds_window_post_unfocus_event(ds_window_t *);
-extern void ds_window_move_req(ds_window_t *, gfx_coord2_t *);
+extern void ds_window_move_req(ds_window_t *, gfx_coord2_t *, sysarg_t);
 extern void ds_window_move(ds_window_t *, gfx_coord2_t *);
 extern void ds_window_get_pos(ds_window_t *, gfx_coord2_t *);
+extern void ds_window_get_max_rect(ds_window_t *, gfx_rect_t *);
 extern void ds_window_resize_req(ds_window_t *, display_wnd_rsztype_t,
-    gfx_coord2_t *);
+    gfx_coord2_t *, sysarg_t);
 extern errno_t ds_window_resize(ds_window_t *, gfx_coord2_t *, gfx_rect_t *);
+extern errno_t ds_window_minimize(ds_window_t *);
+extern errno_t ds_window_unminimize(ds_window_t *);
+extern errno_t ds_window_maximize(ds_window_t *);
+extern errno_t ds_window_unmaximize(ds_window_t *);
 extern void ds_window_calc_resize(ds_window_t *, gfx_coord2_t *,
     gfx_rect_t *);
 extern errno_t ds_window_set_cursor(ds_window_t *, display_stock_cursor_t);
+extern errno_t ds_window_set_caption(ds_window_t *, const char *);
+extern ds_window_t *ds_window_find_next(ds_window_t *, display_wnd_flags_t);
+extern ds_window_t *ds_window_find_prev(ds_window_t *, display_wnd_flags_t);
+extern void ds_window_unfocus(ds_window_t *);
+extern bool ds_window_orig_seat(ds_window_t *, sysarg_t);
 
 #endif
Index: uspace/srv/hid/display/wmclient.c
===================================================================
--- uspace/srv/hid/display/wmclient.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/wmclient.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,223 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server WM client
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <io/log.h>
+#include <stdlib.h>
+#include "display.h"
+#include "window.h"
+#include "wmclient.h"
+
+/** Create WM client.
+ *
+ * @param display Parent display
+ * @param cb WM client callbacks
+ * @param cb_arg Callback argument
+ * @param rwmclient Place to store pointer to new WM client.
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ds_wmclient_create(ds_display_t *display, ds_wmclient_cb_t *cb,
+    void *cb_arg, ds_wmclient_t **rwmclient)
+{
+	ds_wmclient_t *wmclient;
+
+	wmclient = calloc(1, sizeof(ds_wmclient_t));
+	if (wmclient == NULL)
+		return ENOMEM;
+
+	list_initialize(&wmclient->events);
+	wmclient->cb = cb;
+	wmclient->cb_arg = cb_arg;
+
+	ds_display_add_wmclient(display, wmclient);
+
+	*rwmclient = wmclient;
+	return EOK;
+}
+
+/** Destroy WM client.
+ *
+ * @param wmclient WM client
+ */
+void ds_wmclient_destroy(ds_wmclient_t *wmclient)
+{
+	ds_wmclient_purge_events(wmclient);
+	ds_display_remove_wmclient(wmclient);
+	free(wmclient);
+}
+
+/** Get next event from WM client event queue.
+ *
+ * @param wmclient WM client
+ * @param event Place to store event
+ * @return EOK on success, ENOENT if event queue is empty
+ */
+errno_t ds_wmclient_get_event(ds_wmclient_t *wmclient, wndmgt_ev_t *event)
+{
+	link_t *link;
+	ds_wmclient_ev_t *wevent;
+
+	link = list_first(&wmclient->events);
+	if (link == NULL)
+		return ENOENT;
+
+	wevent = list_get_instance(link, ds_wmclient_ev_t, levents);
+	list_remove(link);
+
+	*event = wevent->event;
+	free(wevent);
+	return EOK;
+}
+
+/** Purge events from WM client event queue.
+ *
+ * @param client Client
+ */
+void ds_wmclient_purge_events(ds_wmclient_t *wmclient)
+{
+	link_t *cur;
+	link_t *next;
+	ds_wmclient_ev_t *wevent;
+
+	cur = list_first(&wmclient->events);
+	while (cur != NULL) {
+		next = list_next(cur, &wmclient->events);
+		wevent = list_get_instance(cur, ds_wmclient_ev_t, levents);
+
+		list_remove(cur);
+		free(wevent);
+		cur = next;
+	}
+}
+
+/** Post window added event to the WM client's message queue.
+ *
+ * @param wmclient WM client
+ * @param wnd_id Window ID of the added window
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_wmclient_post_wnd_added_event(ds_wmclient_t *wmclient,
+    sysarg_t wnd_id)
+{
+	ds_wmclient_ev_t *wevent;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "wmclient_pos_wnd_added_event "
+	    "wmclient=%p wnd_id=%zu\n", (void *)wmclient, wnd_id);
+
+	wevent = calloc(1, sizeof(ds_wmclient_ev_t));
+	if (wevent == NULL)
+		return ENOMEM;
+
+	wevent->wmclient = wmclient;
+	wevent->event.etype = wmev_window_added;
+	wevent->event.wnd_id = wnd_id;
+	list_append(&wevent->levents, &wmclient->events);
+
+	/* Notify the client */
+	// TODO Do not send more than once until client drains the queue
+	if (wmclient->cb != NULL && wmclient->cb->ev_pending != NULL)
+		wmclient->cb->ev_pending(wmclient->cb_arg);
+
+	return EOK;
+}
+
+/** Post window removed event to the WM client's message queue.
+ *
+ * @param wmclient WM client
+ * @param wnd_id Window ID of the added window
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_wmclient_post_wnd_removed_event(ds_wmclient_t *wmclient,
+    sysarg_t wnd_id)
+{
+	ds_wmclient_ev_t *wevent;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "wmclient_pos_wnd_removed_event "
+	    "wmclient=%p wnd_id=%zu\n", (void *)wmclient, wnd_id);
+
+	wevent = calloc(1, sizeof(ds_wmclient_ev_t));
+	if (wevent == NULL)
+		return ENOMEM;
+
+	wevent->wmclient = wmclient;
+	wevent->event.etype = wmev_window_removed;
+	wevent->event.wnd_id = wnd_id;
+	list_append(&wevent->levents, &wmclient->events);
+
+	/* Notify the client */
+	// TODO Do not send more than once until client drains the queue
+	if (wmclient->cb != NULL && wmclient->cb->ev_pending != NULL)
+		wmclient->cb->ev_pending(wmclient->cb_arg);
+
+	return EOK;
+}
+
+/** Post window changed event to the WM client's message queue.
+ *
+ * @param wmclient WM client
+ * @param wnd_id Window ID of the added window
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_wmclient_post_wnd_changed_event(ds_wmclient_t *wmclient,
+    sysarg_t wnd_id)
+{
+	ds_wmclient_ev_t *wevent;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "wmclient_pos_wnd_changed_event "
+	    "wmclient=%p wnd_id=%zu\n", (void *)wmclient, wnd_id);
+
+	wevent = calloc(1, sizeof(ds_wmclient_ev_t));
+	if (wevent == NULL)
+		return ENOMEM;
+
+	wevent->wmclient = wmclient;
+	wevent->event.etype = wmev_window_changed;
+	wevent->event.wnd_id = wnd_id;
+	list_append(&wevent->levents, &wmclient->events);
+
+	/* Notify the client */
+	// TODO Do not send more than once until client drains the queue
+	if (wmclient->cb != NULL && wmclient->cb->ev_pending != NULL)
+		wmclient->cb->ev_pending(wmclient->cb_arg);
+
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/srv/hid/display/wmclient.h
===================================================================
--- uspace/srv/hid/display/wmclient.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/wmclient.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server WM client
+ */
+
+#ifndef WMCLIENT_H
+#define WMCLIENT_H
+
+#include <errno.h>
+#include <wndmgt.h>
+#include "types/display/display.h"
+#include "types/display/wmclient.h"
+
+extern errno_t ds_wmclient_create(ds_display_t *, ds_wmclient_cb_t *, void *,
+    ds_wmclient_t **);
+extern void ds_wmclient_destroy(ds_wmclient_t *);
+extern errno_t ds_wmclient_get_event(ds_wmclient_t *,  wndmgt_ev_t *);
+extern errno_t ds_wmclient_post_wnd_added_event(ds_wmclient_t *, sysarg_t);
+extern errno_t ds_wmclient_post_wnd_removed_event(ds_wmclient_t *, sysarg_t);
+extern errno_t ds_wmclient_post_wnd_changed_event(ds_wmclient_t *, sysarg_t);
+extern void ds_wmclient_purge_events(ds_wmclient_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/display/wmops.c
===================================================================
--- uspace/srv/hid/display/wmops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/wmops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,225 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Window management ops implementation
+ */
+
+#include <errno.h>
+#include <io/log.h>
+#include <stdlib.h>
+#include <str.h>
+#include <wndmgt_srv.h>
+#include "display.h"
+#include "seat.h"
+#include "window.h"
+#include "wmclient.h"
+
+static errno_t dispwm_get_window_list(void *, wndmgt_window_list_t **);
+static errno_t dispwm_get_window_info(void *, sysarg_t, wndmgt_window_info_t **);
+static errno_t dispwm_activate_window(void *, sysarg_t, sysarg_t);
+static errno_t dispwm_close_window(void *, sysarg_t);
+static errno_t dispwm_get_event(void *, wndmgt_ev_t *);
+
+wndmgt_ops_t wndmgt_srv_ops = {
+	.get_window_list = dispwm_get_window_list,
+	.get_window_info = dispwm_get_window_info,
+	.activate_window = dispwm_activate_window,
+	.close_window = dispwm_close_window,
+	.get_event = dispwm_get_event,
+};
+
+/** Get window list.
+ *
+ * @param arg Argument (WM client)
+ * @param rlist Place to store pointer to new list
+ * @return EOK on success or an error code
+ */
+static errno_t dispwm_get_window_list(void *arg, wndmgt_window_list_t **rlist)
+{
+	ds_wmclient_t *wmclient = (ds_wmclient_t *)arg;
+	wndmgt_window_list_t *list;
+	ds_window_t *wnd;
+	unsigned i;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispwm_get_window_list()");
+
+	list = calloc(1, sizeof(wndmgt_window_list_t));
+	if (list == NULL)
+		return ENOMEM;
+
+	ds_display_lock(wmclient->display);
+
+	/* Count the number of windows */
+	list->nwindows = 0;
+	wnd = ds_display_first_window(wmclient->display);
+	while (wnd != NULL) {
+		++list->nwindows;
+		wnd = ds_display_next_window(wnd);
+	}
+
+	/* Allocate array for window IDs */
+	list->windows = calloc(list->nwindows, sizeof(sysarg_t));
+	if (list->windows == NULL) {
+		ds_display_unlock(wmclient->display);
+		free(list);
+		return ENOMEM;
+	}
+
+	/* Fill in window IDs */
+	i = 0;
+	wnd = ds_display_first_window(wmclient->display);
+	while (wnd != NULL) {
+		list->windows[i++] = wnd->id;
+		wnd = ds_display_next_window(wnd);
+	}
+
+	ds_display_unlock(wmclient->display);
+	*rlist = list;
+	return EOK;
+}
+
+/** Get window information.
+ *
+ * @param arg Argument (WM client)
+ * @param wnd_id Window ID
+ * @param rinfo Place to store pointer to new window information structure
+ * @return EOK on success or an error code
+ */
+static errno_t dispwm_get_window_info(void *arg, sysarg_t wnd_id,
+    wndmgt_window_info_t **rinfo)
+{
+	ds_wmclient_t *wmclient = (ds_wmclient_t *)arg;
+	ds_window_t *wnd;
+	wndmgt_window_info_t *info;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispwm_get_window_info()");
+
+	ds_display_lock(wmclient->display);
+	wnd = ds_display_find_window(wmclient->display, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(wmclient->display);
+		return ENOENT;
+	}
+
+	info = calloc(1, sizeof(wndmgt_window_info_t));
+	if (info == NULL) {
+		ds_display_unlock(wmclient->display);
+		return ENOMEM;
+	}
+
+	info->caption = str_dup(wnd->caption);
+	if (info->caption == NULL) {
+		ds_display_unlock(wmclient->display);
+		free(info);
+		return ENOMEM;
+	}
+
+	info->flags = wnd->flags;
+	info->nfocus = wnd->nfocus;
+
+	ds_display_unlock(wmclient->display);
+	*rinfo = info;
+	return EOK;
+}
+
+/** Activate window.
+ *
+ * @param arg Argument (WM client)
+ * @param dev_id Input device ID
+ * @param wnd_id Window ID
+ * @return EOK on success or an error code
+ */
+static errno_t dispwm_activate_window(void *arg, sysarg_t dev_id,
+    sysarg_t wnd_id)
+{
+	ds_wmclient_t *wmclient = (ds_wmclient_t *)arg;
+	ds_window_t *wnd;
+	ds_seat_t *seat;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispwm_activate_window()");
+
+	ds_display_lock(wmclient->display);
+	wnd = ds_display_find_window(wmclient->display, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(wmclient->display);
+		return ENOENT;
+	}
+
+	/* Determine which seat's focus should be changed */
+	seat = ds_display_seat_by_idev(wnd->display, dev_id);
+	if (seat == NULL) {
+		ds_display_unlock(wmclient->display);
+		return ENOENT;
+	}
+
+	/* Switch focus */
+	ds_seat_set_focus(seat, wnd);
+
+	ds_display_unlock(wmclient->display);
+	return EOK;
+}
+
+/** Close window.
+ *
+ * @param arg Argument (WM client)
+ * @param wnd_id Window ID
+ * @return EOK on success or an error code
+ */
+static errno_t dispwm_close_window(void *arg, sysarg_t wnd_id)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispwm_close_window()");
+	(void)arg;
+	(void)wnd_id;
+	return EOK;
+}
+
+/** Get window management event.
+ *
+ * @param arg Argument (WM client)
+ * @param ev Place to store event
+ * @return EOK on success, ENOENT if there are no events
+ */
+static errno_t dispwm_get_event(void *arg, wndmgt_ev_t *ev)
+{
+	ds_wmclient_t *wmclient = (ds_wmclient_t *)arg;
+	errno_t rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispwm_get_event()");
+
+	ds_display_lock(wmclient->display);
+	rc = ds_wmclient_get_event(wmclient, ev);
+	ds_display_unlock(wmclient->display);
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/srv/hid/display/wmops.h
===================================================================
--- uspace/srv/hid/display/wmops.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/wmops.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Window management ops implementation
+ */
+
+#ifndef WMOPS_H
+#define WMOPS_H
+
+#include <wndmgt_srv.h>
+
+extern wndmgt_ops_t wndmgt_srv_ops;
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/input/ctl/stty.c
===================================================================
--- uspace/srv/hid/input/ctl/stty.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/ctl/stty.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -228,4 +228,6 @@
 	0,	KC_RIGHT,	0x1b, 0x5b, 0x43, GSP_END,
 
+	/* Ctrl + key */
+
 	KM_CTRL, 	KC_Q,		0x11, GSP_END,
 	KM_CTRL, 	KC_W,		0x17, GSP_END,
@@ -253,4 +255,62 @@
 	KM_CTRL,	KC_N,		0x0e, GSP_END,
 
+	/* Alt + key */
+
+	KM_ALT,	KC_BACKTICK,	0x1b, 0x60, GSP_END,
+
+	KM_ALT,	KC_1,		0x1b, 0x31, GSP_END,
+	KM_ALT,	KC_2,		0x1b, 0x32, GSP_END,
+	KM_ALT,	KC_3,		0x1b, 0x33, GSP_END,
+	KM_ALT,	KC_4,		0x1b, 0x34, GSP_END,
+	KM_ALT,	KC_5,		0x1b, 0x35, GSP_END,
+	KM_ALT,	KC_6,		0x1b, 0x36, GSP_END,
+	KM_ALT,	KC_7,		0x1b, 0x37, GSP_END,
+	KM_ALT,	KC_8,		0x1b, 0x38, GSP_END,
+	KM_ALT,	KC_9,		0x1b, 0x39, GSP_END,
+	KM_ALT,	KC_0,		0x1b, 0x30, GSP_END,
+
+	KM_ALT,	KC_MINUS,	0x1b, 0x2d, GSP_END,
+	KM_ALT,	KC_EQUALS,	0x1b, 0x3d, GSP_END,
+
+	KM_ALT,	KC_Q,		0x1b, 0x71, GSP_END,
+	KM_ALT,	KC_W,		0x1b, 0x77, GSP_END,
+	KM_ALT,	KC_E,		0x1b, 0x65, GSP_END,
+	KM_ALT,	KC_R,		0x1b, 0x72, GSP_END,
+	KM_ALT,	KC_T,		0x1b, 0x74, GSP_END,
+	KM_ALT,	KC_Y,		0x1b, 0x79, GSP_END,
+	KM_ALT,	KC_U,		0x1b, 0x75, GSP_END,
+	KM_ALT,	KC_I,		0x1b, 0x69, GSP_END,
+	KM_ALT,	KC_O,		0x1b, 0x6f, GSP_END,
+	KM_ALT,	KC_P,		0x1b, 0x70, GSP_END,
+
+	/* 0x1b, 0x5b is used by other keys/sequences */
+	KM_ALT,	KC_RBRACKET,	0x1b, 0x5d, GSP_END,
+
+	KM_ALT,	KC_A,		0x1b, 0x61, GSP_END,
+	KM_ALT,	KC_S,		0x1b, 0x73, GSP_END,
+	KM_ALT,	KC_D,		0x1b, 0x64, GSP_END,
+	KM_ALT,	KC_F,		0x1b, 0x66, GSP_END,
+	KM_ALT,	KC_G,		0x1b, 0x67, GSP_END,
+	KM_ALT,	KC_H,		0x1b, 0x68, GSP_END,
+	KM_ALT,	KC_J,		0x1b, 0x6a, GSP_END,
+	KM_ALT,	KC_K,		0x1b, 0x6b, GSP_END,
+	KM_ALT,	KC_L,		0x1b, 0x6c, GSP_END,
+
+	KM_ALT,	KC_SEMICOLON,	0x1b, 0x3b, GSP_END,
+	KM_ALT,	KC_QUOTE,	0x1b, 0x27, GSP_END,
+	KM_ALT,	KC_BACKSLASH,	0x1b, 0x5c, GSP_END,
+
+	KM_ALT,	KC_Z,		0x1b, 0x7a, GSP_END,
+	KM_ALT,	KC_X,		0x1b, 0x78, GSP_END,
+	KM_ALT,	KC_C,		0x1b, 0x63, GSP_END,
+	KM_ALT,	KC_V,		0x1b, 0x76, GSP_END,
+	KM_ALT,	KC_B,		0x1b, 0x62, GSP_END,
+	KM_ALT,	KC_N,		0x1b, 0x6e, GSP_END,
+	KM_ALT,	KC_M,		0x1b, 0x6d, GSP_END,
+
+	KM_ALT,	KC_COMMA,	0x1b, 0x2c, GSP_END,
+	KM_ALT,	KC_PERIOD,	0x1b, 0x2e, GSP_END,
+	KM_ALT,	KC_SLASH,	0x1b, 0x2f, GSP_END,
+
 	/*
 	 * Sequences specific to Gnome terminal
Index: uspace/srv/hid/input/gsp.c
===================================================================
--- uspace/srv/hid/input/gsp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/gsp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -84,5 +84,5 @@
 }
 
-static hash_table_ops_t trans_ops = {
+static const hash_table_ops_t trans_ops = {
 	.hash = trans_hash,
 	.key_hash = trans_key_hash,
Index: uspace/srv/hid/input/input.c
===================================================================
--- uspace/srv/hid/input/input.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/input.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2006 Josef Cejka
- * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -253,5 +253,6 @@
 		if (client->active) {
 			async_exch_t *exch = async_exchange_begin(client->sess);
-			async_msg_4(exch, INPUT_EVENT_KEY, ev.type, ev.key, ev.mods, ev.c);
+			async_msg_5(exch, INPUT_EVENT_KEY, kdev->svc_id,
+			    ev.type, ev.key, ev.mods, ev.c);
 			async_exchange_end(exch);
 		}
@@ -267,5 +268,6 @@
 
 			if ((dx) || (dy))
-				async_msg_2(exch, INPUT_EVENT_MOVE, dx, dy);
+				async_msg_3(exch, INPUT_EVENT_MOVE,
+				    mdev->svc_id, dx, dy);
 
 			if (dz) {
@@ -274,7 +276,10 @@
 
 				for (unsigned int i = 0; i < 3; i++)
-					async_msg_4(exch, INPUT_EVENT_KEY, KEY_PRESS, code, 0, 0);
-
-				async_msg_4(exch, INPUT_EVENT_KEY, KEY_RELEASE, code, 0, 0);
+					async_msg_5(exch, INPUT_EVENT_KEY,
+					    0 /* XXX kbd_id */,
+					    KEY_PRESS, code, 0, 0);
+
+				async_msg_5(exch, INPUT_EVENT_KEY, KEY_RELEASE,
+				    0 /* XXX kbd_id */, code, 0, 0);
 			}
 
@@ -292,5 +297,6 @@
 			if ((max_x) && (max_y)) {
 				async_exch_t *exch = async_exchange_begin(client->sess);
-				async_msg_4(exch, INPUT_EVENT_ABS_MOVE, x, y, max_x, max_y);
+				async_msg_5(exch, INPUT_EVENT_ABS_MOVE,
+				    mdev->svc_id, x, y, max_x, max_y);
 				async_exchange_end(exch);
 			}
@@ -305,5 +311,6 @@
 		if (client->active) {
 			async_exch_t *exch = async_exchange_begin(client->sess);
-			async_msg_2(exch, INPUT_EVENT_BUTTON, bnum, press);
+			async_msg_3(exch, INPUT_EVENT_BUTTON, mdev->svc_id,
+			    bnum, press);
 			async_exchange_end(exch);
 		}
@@ -311,5 +318,18 @@
 }
 
-/** Arbitrate client actiovation */
+/** Mouse button has been double-clicked. */
+void mouse_push_event_dclick(mouse_dev_t *mdev, int bnum)
+{
+	list_foreach(clients, link, client_t, client) {
+		if (client->active) {
+			async_exch_t *exch = async_exchange_begin(client->sess);
+			async_msg_2(exch, INPUT_EVENT_DCLICK, mdev->svc_id,
+			    bnum);
+			async_exchange_end(exch);
+		}
+	}
+}
+
+/** Arbitrate client activation */
 static void client_arbitration(void)
 {
@@ -858,4 +878,5 @@
 {
 	errno_t rc;
+	loc_srv_t *srv;
 
 	if (argc < 2) {
@@ -881,5 +902,5 @@
 	async_set_fallback_port_handler(client_connection, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register server\n", NAME);
@@ -888,5 +909,5 @@
 
 	service_id_t service_id;
-	rc = loc_service_register(argv[1], &service_id);
+	rc = loc_service_register(srv, argv[1], &service_id);
 	if (rc != EOK) {
 		printf("%s: Unable to register service %s\n", NAME, argv[1]);
Index: uspace/srv/hid/input/layout/ar.c
===================================================================
--- uspace/srv/hid/input/layout/ar.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/layout/ar.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -216,8 +216,4 @@
 	char32_t c;
 
-	/* Produce no characters when Ctrl or Alt is pressed. */
-	if ((ev->mods & (KM_CTRL | KM_ALT)) != 0)
-		return 0;
-
 	c = translate(ev->key, map_neutral, sizeof(map_neutral) / sizeof(char32_t));
 	if (c != 0)
Index: uspace/srv/hid/input/layout/cz.c
===================================================================
--- uspace/srv/hid/input/layout/cz.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/layout/cz.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -322,8 +322,4 @@
 	char32_t c;
 
-	/* Produce no characters when Ctrl or Alt is pressed. */
-	if ((ev->mods & (KM_CTRL | KM_ALT)) != 0)
-		return 0;
-
 	if (ev->key == KC_EQUALS) {
 		if ((ev->mods & KM_SHIFT) != 0)
Index: uspace/srv/hid/input/layout/fr_azerty.c
===================================================================
--- uspace/srv/hid/input/layout/fr_azerty.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/layout/fr_azerty.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -223,7 +223,4 @@
 static char32_t fr_azerty_parse_ev (layout_t *s, kbd_event_t *e)
 {
-	if ((e->mods & (KM_CTRL | KM_ALT)))
-		return 0; // Produce no characters when Ctrl or Alt is pressed
-
 	char32_t c = translate (e->key, map_neutral, sizeof (map_neutral) / sizeof (char32_t));
 	if (c)
Index: uspace/srv/hid/input/layout/us_dvorak.c
===================================================================
--- uspace/srv/hid/input/layout/us_dvorak.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/layout/us_dvorak.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -225,8 +225,4 @@
 	char32_t c;
 
-	/* Produce no characters when Ctrl or Alt is pressed. */
-	if ((ev->mods & (KM_CTRL | KM_ALT)) != 0)
-		return 0;
-
 	c = translate(ev->key, map_neutral, sizeof(map_neutral) / sizeof(char32_t));
 	if (c != 0)
Index: uspace/srv/hid/input/layout/us_qwerty.c
===================================================================
--- uspace/srv/hid/input/layout/us_qwerty.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/layout/us_qwerty.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -219,8 +219,4 @@
 	char32_t c;
 
-	/* Produce no characters when Ctrl or Alt is pressed. */
-	if ((ev->mods & (KM_CTRL | KM_ALT)) != 0)
-		return 0;
-
 	c = translate(ev->key, map_neutral, sizeof(map_neutral) / sizeof(char32_t));
 	if (c != 0)
Index: uspace/srv/hid/input/meson.build
===================================================================
--- uspace/srv/hid/input/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,5 +28,5 @@
 #
 
-deps = [ 'drv' ]
+deps = [ 'drv', 'console', 'input' ]
 src = files(
 	'layout/cz.c',
Index: uspace/srv/hid/input/mouse.h
===================================================================
--- uspace/srv/hid/input/mouse.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/mouse.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,4 +66,5 @@
     unsigned int, unsigned int);
 extern void mouse_push_event_button(mouse_dev_t *, int, int);
+extern void mouse_push_event_dclick(mouse_dev_t *, int);
 
 #endif
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -43,4 +44,5 @@
 #include <loc.h>
 #include <stdlib.h>
+#include <time.h>
 #include "../mouse.h"
 #include "../mouse_port.h"
@@ -48,8 +50,17 @@
 #include "../input.h"
 
+enum {
+	/** Default double-click speed in milliseconds */
+	dclick_delay_ms = 500
+};
+
 /** Mousedev softstate */
 typedef struct {
 	/** Link to generic mouse device */
 	mouse_dev_t *mouse_dev;
+	/** Button number of last button pressed (or -1 if none) */
+	int press_bnum;
+	/** Time at which button was last pressed */
+	struct timespec press_time;
 } mousedev_t;
 
@@ -61,4 +72,5 @@
 
 	mousedev->mouse_dev = mdev;
+	mousedev->press_bnum = -1;
 
 	return mousedev;
@@ -68,4 +80,28 @@
 {
 	free(mousedev);
+}
+
+static void mousedev_press(mousedev_t *mousedev, int bnum)
+{
+	struct timespec now;
+	nsec_t ms_delay;
+
+	getuptime(&now);
+
+	/* Same button was pressed previously */
+	if (mousedev->press_bnum == bnum) {
+		/* Compute milliseconds since previous press */
+		ms_delay = ts_sub_diff(&now, &mousedev->press_time) / 1000000;
+
+		if (ms_delay <= dclick_delay_ms) {
+			mouse_push_event_dclick(mousedev->mouse_dev, bnum);
+			mousedev->press_bnum = -1;
+			return;
+		}
+	}
+
+	/* Record which button was last pressed and at what time */
+	mousedev->press_bnum = bnum;
+	mousedev->press_time = now;
 }
 
@@ -103,4 +139,6 @@
 			mouse_push_event_button(mousedev->mouse_dev,
 			    ipc_get_arg1(&call), ipc_get_arg2(&call));
+			if (ipc_get_arg2(&call) != 0)
+				mousedev_press(mousedev, ipc_get_arg1(&call));
 			retval = EOK;
 			break;
